module Main where
import Prelude hiding (($), (!!))
import Data.Char (toUpper, toLower)
import Test.QuickCheck
import Debug.Trace

isPalindrome :: String -> Bool
isPalindrome s | length s < 2 = True
isPalindrome s =
  let s' = reverse s
  in and [ traceShow (x,y) (toUpper x == toUpper y)
         | x <- s , y <- s' ]


main :: IO ()
main = do putStrLn "A single character is a palindrome:"
          quickCheck (\c -> isPalindrome [c])
          putStrLn "... the other test ..."
          quickCheck (\c str ->
                        isPalindrome ([toUpper c] ++ str ++ [c])
                        == isPalindrome str)
